//Задача "Память подводит"
//4-ая личная интернет-олимпиада сезона 2009-2010
//Автор задачи: 
//Автор решения: Ганеев Рустам, ganeev@rain.ifmo.ru
//Неверное решение - количество строк больше 10000
import java.io.*;
import java.util.*;
import java.math.*;

public class memory_rg_wa implements Runnable {

	public static void main(String[] args) {
		new Thread(new memory_rg_wa()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String FNAME = "memory";

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error(message);
		}
	}
	int gcd(int n, int m){
		return m == 0 ? n : gcd(m, n % m);
	}
	
	String writeTime(int a, int b){
		int nod = gcd(Math.max(a, b), Math.min(a, b));
		return (Integer.toString(a / nod) + "/"+ Integer.toString(b / nod));
	}

	private void solve() throws IOException {
		int n = nextInt(), m = nextInt();
		int k = nextInt();
		myAssert(n <= 1000 && n >= 1 && m <= 1000 && m >= 1 && k >= 1
				&& k <= 1000, "Wrong n, m, k values");
		if (n <= m) {
			out.println(k);
			out.println(n);
			for (int i = 0; i < n; i++) {
				out.println("0/1: Connect " + (i + 1) + " to " + (i + 1));
			}
		} else {
			double ans = k / m;
			out.println(writeTime(n * k, m));
			double time = 0, maxt = n * ans;
			ArrayList<String> dic = new ArrayList<String>();
			int shift = -1, p = -1;
			for (time = 0; time < maxt; time += ans) {
				p++;
				for (int i = 1; i <= m; i++) {
					shift = (shift + 1) % n;
					dic.add(writeTime(p * k, m) + ": Connect " + i + " to " + (shift + 1));
				}
			}
			out.println(dic.size());
			for (String s : dic) {
				out.println(s);
			}
		}
	}
}
